Index: bootscripts/ChangeLog
===================================================================
--- bootscripts/ChangeLog	(revision 9f0c94b408fb26d3b9cbc8844637304c72560c2f)
+++ bootscripts/ChangeLog	(revision b3d94f390cb8d9febeff2581a8f66515fd8f7508)
@@ -1,2 +1,10 @@
+2023-07-22 Xi Ruoyao <xry111@xry111.site>
+   * In mountvirtfs, create symlinks /dev/{fd,std{in,out,err}} and
+     /dev/core (optional).
+
+2023-07-16 Xi Ruoyao <xry111@xry111.site>
+   * In udev, set SYSTEMD_LOG_TARGET=kmsg so systemd-udevd will correctly
+     log messages.
+
 2023-07-15 Xi Ruoyao <xry111@xry111.site>
    * Use /bin/udevadm instead of /sbin/udevadm.
Index: bootscripts/lfs/init.d/mountvirtfs
===================================================================
--- bootscripts/lfs/init.d/mountvirtfs	(revision 9f0c94b408fb26d3b9cbc8844637304c72560c2f)
+++ bootscripts/lfs/init.d/mountvirtfs	(revision b3d94f390cb8d9febeff2581a8f66515fd8f7508)
@@ -8,6 +8,7 @@
 #               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
+#               Xi Ruoyao - xry111@xry111.site
 #
-# Version     : LFS 7.0
+# Version     : LFS 12.0
 #
 ########################################################################
@@ -65,4 +66,27 @@
       (exit ${failed})
       evaluate_retval
+      if [ "${failed}" = 1 ]; then
+         exit 1
+      fi
+
+      log_info_msg "Create symlinks in /dev targeting /proc: ${INFO}/dev/stdin"
+      ln -sf /proc/self/fd/0 /dev/stdin  || failed=1
+
+      log_info_msg2 " ${INFO}/dev/stdout"
+      ln -sf /proc/self/fd/1 /dev/stdout || failed=1
+
+      log_info_msg2 " ${INFO}/dev/stderr"
+      ln -sf /proc/self/fd/2 /dev/stderr || failed=1
+
+      log_info_msg2 " ${INFO}/dev/fd"
+      ln -sf /proc/self/fd   /dev/fd     || failed=1
+
+      if [ -e /proc/kcore ]; then
+         log_info_msg2 " ${INFO}/dev/core"
+         ln -sf /proc/kcore  /dev/core   || failed=1
+      fi
+
+      (exit ${failed})
+      evaluate_retval
       exit $failed
       ;;
Index: bootscripts/lfs/init.d/udev
===================================================================
--- bootscripts/lfs/init.d/udev	(revision 9f0c94b408fb26d3b9cbc8844637304c72560c2f)
+++ bootscripts/lfs/init.d/udev	(revision b3d94f390cb8d9febeff2581a8f66515fd8f7508)
@@ -8,6 +8,7 @@
 #               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
+#               Xi Ruoyao - xry111@xry111.site
 #
-# Version     : LFS 7.0
+# Version     : LFS 12.0
 #
 ########################################################################
Index: chapter01/changelog.xml
===================================================================
--- chapter01/changelog.xml	(revision 9f0c94b408fb26d3b9cbc8844637304c72560c2f)
+++ chapter01/changelog.xml	(revision b3d94f390cb8d9febeff2581a8f66515fd8f7508)
@@ -41,4 +41,15 @@
     -->
 
+    <listitem revision='sysv'>
+      <para>2023-07-22</para>
+      <itemizedlist>
+        <listitem revision='sysv'>
+          <para>[xry111] - Make the mountvirtfs bootscript create essential
+          symlinks in /dev.  Fixes
+          <ulink url='&lfs-ticket-root;5289'>#5289</ulink>.</para>
+        </listitem>
+      </itemizedlist>
+    </listitem>
+
     <listitem>
       <para>2023-07-15</para>
Index: chapter10/kernel.xml
===================================================================
--- chapter10/kernel.xml	(revision 9f0c94b408fb26d3b9cbc8844637304c72560c2f)
+++ chapter10/kernel.xml	(revision b3d94f390cb8d9febeff2581a8f66515fd8f7508)
@@ -464,6 +464,5 @@
     <para>Install the documentation for the Linux kernel:</para>
 
-<screen><userinput remap="install">install -d /usr/share/doc/linux-&linux-version;
-cp -r Documentation/* /usr/share/doc/linux-&linux-version;</userinput></screen>
+<screen><userinput remap="install">cp -r Documentation -T /usr/share/doc/linux-&linux-version;</userinput></screen>
 
     <para>It is important to note that the files in the kernel source
Index: packages.ent
===================================================================
--- packages.ent	(revision 9f0c94b408fb26d3b9cbc8844637304c72560c2f)
+++ packages.ent	(revision b3d94f390cb8d9febeff2581a8f66515fd8f7508)
@@ -393,5 +393,5 @@
 <!ENTITY less-fin-sbu "less than 0.1 SBU">
 
-<!ENTITY lfs-bootscripts-version "20230716">      <!-- Scripts depend on this format -->
+<!ENTITY lfs-bootscripts-version "20230722">      <!-- Scripts depend on this format -->
 <!ENTITY lfs-bootscripts-size "BOOTSCRIPTS-SIZE KB">
 <!ENTITY lfs-bootscripts-url "&downloads-root;lfs-bootscripts-&lfs-bootscripts-version;.tar.xz">
